/*
   (c) Copyright 2000  convergence integrated media GmbH.
   All rights reserved.

   Written by Denis Oliver Kropp <dok@convergence.de> and
              Andreas Hundt <andi@convergence.de>.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef ___EMMA_H__
#define ___EMMA_H__

#include <asm/types.h>
#include <mmac/hardware/hwgblt.h>
#include <core/coretypes.h>

typedef struct {
     volatile EMMA_GBLT *mmio_base;
} EMMADriverData;

typedef struct {
     CoreSurface *source;
     CoreSurface *destination;
     DFBSurfaceBlittingFlags blittingflags;
     CardState *state;
     int source_fields;
     int source_pitch;
     int dest_fields;
     int dest_pitch;
     int estimated_usecs;
     unsigned short *system_dst0top;
     unsigned short *system_dst0bot;
     unsigned short *system_src0top;
     unsigned short *system_src0bot;
} EMMADeviceData;

void
emma_init_layers( void *drv, void *dev );

extern  EMMA_GBLT *mmio_copy;

#define FBMEM_OFFSET (0x1000) 

#endif
