/********************************************************************* 
*
* Copyright 2002 DiscVision GmbH 
*
* Filename: $RCSfile: debugtime.h,v $
* Revision: $Revision: 1.4 $
*
* Written by $Author: rkluthe $ / $Date: 2003/01/10 10:48:12 $.
*
*
* This file is the property of DiscVision GmbH. The unauthorised use,
* copy and transfer of all or any part of this file is forbidden.
*
*********************************************************************/
#include <sys/time.h>
struct _timedebug {
    struct timeval _ta,_tb;
    long long _sum1,_sum2;
    int _first; 
    char *name;
    struct _timedebug *next;
};
#ifdef DEBUGTIME_MAIN
struct _timedebug *_debugtime_list = NULL;
#else
extern struct _timedebug *_debugtime_list;
#endif

#define _debugtime_print() \
{ \
    struct _timedebug *p; \
    for(p = _debugtime_list;p;p=p->next) \
	fprintf(stderr,"%20s self:%8lld other:%8lld\n",p->name,p->_sum2/1000,p->_sum1/1000); \
}

#define TDIF(a,b) ((a.tv_sec-b.tv_sec)*1000000LL+a.tv_usec-b.tv_usec)
#ifdef DEBUGTIME
#define LOGTIME(x) { struct timeval ta; gettimeofday(&ta,NULL); fprintf(stderr,"%s %7d %5d\n",x,ta.tv_sec,ta.tv_usec); }
#define LOGTIME1 { static struct _timedebug _tdbg = { _first:1,_sum1:0,_sum2:0 }; \
    gettimeofday(&_tdbg._ta,NULL); if(!_tdbg._first) _tdbg._sum1+=TDIF(_tdbg._ta,_tdbg._tb);  
#define LOGTIME2(x) gettimeofday(&_tdbg._tb,NULL); \
    if(_tdbg._first) { \
	_tdbg.next = _debugtime_list; \
	_debugtime_list = &_tdbg; \
	_tdbg.name = x;  \
    } \
    _tdbg._first=0; _tdbg._sum2+=TDIF(_tdbg._tb,_tdbg._ta); \
    }
#define LOGTIME3(x) gettimeofday(&_tdbg._tb,NULL); \
    if(_tdbg._first) { \
	_tdbg.next = _debugtime_list; \
	_debugtime_list = &_tdbg; \
	_tdbg.name = x;  \
    } \
    _tdbg._first=0; _tdbg._sum2+=TDIF(_tdbg._tb,_tdbg._ta); 
#else
#define LOGTIME(x)
#define LOGTIME1
#define LOGTIME2(x)
#define LOGTIME3(x)
#endif



