#include <stdio.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <hw_idct.h>

#define JPEG_INTERNALS
#include "jinclude.h"
#include "jpeglib.h"
#include "jdct.h"		/* Private declarations for DCT subsystem */
#define DEBUGPRINT
int hw_idct_woffset = 0;
short *hw_idct_in = NULL;
unsigned char *hw_idct_out = NULL;
int hw_idct_row = 0;
static int fd_idct_dev = 0;

int jpeg_idct_hw_init()
{
    if(fd_idct_dev > 0) /* already done */
	return 0;
    if(fd_idct_dev == 0)
	fd_idct_dev = open("/dev/hw_idct",O_RDWR);
    if(fd_idct_dev < 0) /* error */
	return -1;
    hw_idct_in = mmap(NULL,3*HW_IDCT_BUF_SIZE,PROT_READ | PROT_WRITE,MAP_SHARED,fd_idct_dev,0);
    if( ((int) hw_idct_in ) == -1) {
	perror("idct mmap");
	close(fd_idct_dev);
	fd_idct_dev = -1;
	return -1;
    }
    hw_idct_out = (unsigned char *) (hw_idct_in + HW_IDCT_BUF_SIZE);
    return 0;
}

int jpeg_idct_hw_run(j_decompress_ptr cinfo,int sync)
{
    int i,j,k;
    unsigned char *p;
    unsigned short *s;
    if(!sync && hw_idct_woffset < HW_IDCT_MAX - 12)
	return 0;
#if 0
    /*
    s = hw_idct_in;
    for(i=0;i<hw_idct_woffset;i++)
        s[64*i] += 1024;
    */
    s = hw_idct_in;
    for(i=0;i<hw_idct_woffset;i++) {
	if(1) {
	    fprintf(stderr,"input block %d:\n",i);
	    for(k=0;k<8;k++) {
		for(j=0;j<8;j++) {
		    fprintf(stderr,"%04x ",*s);
		    s++;
		}
		fprintf(stderr,"\n");
	    }
	} 
    }
#endif
    if( ioctl(fd_idct_dev,1,hw_idct_woffset) != 0) {
	perror("hw_idct_ioctl");
	return -1;
    }
    // fprintf(stderr,"after decode:\n-------------\n");
    /*
    s = hw_idct_in;
    for(i=0;i<hw_idct_woffset;i++) {
	if(1) {
	    fprintf(stderr,"input block %d:\n",i);
	    for(k=0;k<8;k++) {
		for(j=0;j<8;j++) {
		    fprintf(stderr,"%04x ",*s);
		    s++;
		}
		fprintf(stderr,"\n");
	    }
	} 
    }
    */
#if 0
    p = hw_idct_out;
    for(i=0;i<hw_idct_woffset;i++) {
	if(1) {
	    fprintf(stderr,"output block %d:\n",i);
	    for(k=0;k<8;k++) {
		for(j=0;j<8;j++) {
		    fprintf(stderr,"%02x ",*p);
		    p++;
		}
		fprintf(stderr,"\n");
	    }
	} else
	    p+=64;
    }
#endif
    hw_idct_row = 0;
    hw_idct_woffset = 0;
    return 0;
}

#define DEQUANTIZE(coef,quantval)  (((int) (coef)) * (quantval))

void jpeg_idct_hw (j_decompress_ptr cinfo, jpeg_component_info * compptr,
		 JCOEFPTR coef_block,
		 JSAMPARRAY output_buf, JDIMENSION output_col)
{ 
    hw_idct_woffset ++;
}
