/*
  File: acl_extended_fd.c

  Copyright (C) 2000
  Andreas Gruenbacher, <a.gruenbacher@computer.org>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "linux.h"


int
acl_extended_fd(
	int fd)
{
	char *names;
	int retval, extended = 0;

	retval = __attr_get_fd(fd, NULL, &names, 256);
	if (retval < 0) {
		if (errno == ENOATTR)
			return 0;
		return -1;
	}
	else if (retval > 0) {
		char *n;

		for (n = names; *n != '\0'; n += strlen(n)+1) {
			if (strcmp(n, ACL_EA_ACCESS) == 0) {
				extended = 1;
				break;
			}
			if (strcmp(n, ACL_EA_DEFAULT) == 0) {
				extended = 1;
				break;
			}
		}
	}
	free(names);
	return extended;
}

