/*
  File: acl_set_fd.c

  Copyright (C) 1999, 2000
  Andreas Gruenbacher, <a.gruenbacher@computer.org>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <sys/stat.h>
#include "linux.h"


/* 23.4.21 */
int
acl_set_fd(
	int fd,
	acl_t acl)
{
	acl_obj *acl_obj_p = ext2int(acl, acl);
	char *ext_acl_p;
	size_t size;
	int error;

	if (!acl_obj_p)
		return -1;
	ext_acl_p = __acl_copy_ext(acl_obj_p, &size);
	if (!ext_acl_p)
		return -1;
	error = fsetxattr(fd, ACL_EA_ACCESS, ext_acl_p, size, 0);
	free(ext_acl_p);
	return error;
}

