#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <asm/types.h>
#include <linux/acl_ea.h>
#include "sys/acl.h"
#include "../byteorder.h"
#include "acl/libacl.h"

#include "../__libacl.h"

int
__attr_get_file(
        const char *path_p,
	const char *name,
	char **value,
	size_t size_hint);
int
__attr_get_fd(
        int fd,
	const char *name,
	char **value,
	size_t size_hint);
acl_t
__acl_copy_int(
	const char *ext_acl_p,
	size_t size);
char *
__acl_copy_ext(
	const acl_obj *acl_obj_p,
	size_t *size);

#ifndef ENOATTR
#define ENOATTR ENODATA
#endif

#define XATTR_CREATE  0x1	/* set value, fail if attr already exists */
#define XATTR_REPLACE 0x2	/* set value, fail if attr does not exist */

int  setxattr(const char *, const char *, void *, size_t, int);
int lsetxattr(const char *, const char *, void *, size_t, int);
int fsetxattr(int,          const char *, void *, size_t, int);

ssize_t  getxattr(const char *, const char *, void *, size_t);
ssize_t lgetxattr(const char *, const char *, void *, size_t);
ssize_t fgetxattr(int,          const char *, void *, size_t);

ssize_t  listxattr(const char *, char *, size_t);
ssize_t llistxattr(const char *, char *, size_t);
ssize_t flistxattr(int,  char *, size_t);

int  removexattr(const char *, const char *);
int lremovexattr(const char *, const char *);
int fremovexattr(int,          const char *);

