/*
 * linux/arch/mips/vr41xx/ibm_workpad.c
 *
 * Platform support for IBM WORKPAD
 *
 * Copyright (C) 2000 SATO Kazumi
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 */

#include <asm/system.h>
#include <asm/io.h>
#include <asm/vr41xx.h>

extern int ite8181_backlight(int);
extern int get_ite8181_backlight(int);
extern int ite8181_contrast(int);
extern int get_ite8181_contrast(int);
extern int ite8181_lcdpower(int);
extern void ite8181_setup(void);

int display_set_backlight(int n)
{
	return ite8181_backlight(n);
}

int display_get_backlight(int n)
{
	return get_ite8181_backlight(n);
}

int display_set_contrast(int n)
{
	return ite8181_contrast(n);
}

int display_get_contrast(int n)
{
	return get_ite8181_contrast(n);
}

int display_power(int n)
{
	return ite8181_lcdpower(n);
}

void platdep_setup(void)
{
	ite8181_setup();
}
