/*
 * linux/arch/mips/vr41xx/nec_mobilegear2_r430.c
 *
 * Platform support for NEC MobileGear2 R430/R530, DOCOMO sigmarion
 *
 * Copyright (C) 2000 SATO Kazumi
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 */
#include <linux/kernel.h>
#include <asm/io.h>
#include <asm/vr41xx.h>

extern int mq200_backlight(int);
extern int get_mq200_backlight(void);
extern int mq200_contrast(int);
extern int get_mq200_contrast(void);
extern int mq200_lcdpower(int);
extern void mq200_setup(void);

extern int vrc4172pwm_backlight(int);
extern int get_vrc4172pwm_backlight(int);
extern int vrc4172pwm_contrast(int);
extern int get_vrc4172pwm_contrast(int);
extern int vrc4172pwm_lcdpower(int);
extern void vrc4172pwm_setup(void);

int display_set_backlight(int n)
{
	if (n == 0) {
		mq200_lcdpower(0);
		mq200_backlight(n);
	} else {
		mq200_lcdpower(1);
		mq200_backlight(n);
	}
	vrc4172pwm_backlight(n);
	return 0;
}

int display_get_backlight(int n)
{
	return get_vrc4172pwm_backlight(n);
}

int display_set_contrast(int n)
{
	mq200_contrast(n);
	vrc4172pwm_contrast(n);
	return 0;
}

int display_get_contrast(int n)
{
	return get_mq200_contrast();
}

int display_power(int n)
{
	mq200_lcdpower(n);
	vrc4172pwm_lcdpower(n);
	return 0;
}

void platdep_setup(void)
{
	mq200_setup();
	vrc4172pwm_setup();
}
