	;; $Id: firmware.asm,v 1.6 2000/02/09 12:33:15 tom Exp $	
	.module main

	;; define code segments link order
	.area CODE (CODE)
	.area CSEG (CODE)
	.area GSINIT (CODE)
	.area GSINIT2 (CODE)

	;; -----------------------------------------------------

	;; special function registers (which are not predefined)
	dpl0    = 0x82
	dph0    = 0x83
	dpl1    = 0x84
	dph1    = 0x85
	dps     = 0x86
	ckcon   = 0x8E
	spc_fnc = 0x8F
	exif    = 0x91
	mpage   = 0x92
	scon0   = 0x98
	sbuf0   = 0x99
	scon1   = 0xC0
	sbuf1   = 0xC1
	eicon   = 0xD8
	eie     = 0xE8
	eip     = 0xF8

	;; anchor xdata registers
	IN0BUF		= 0x7F00
	OUT0BUF		= 0x7EC0
	IN1BUF		= 0x7E80
	OUT1BUF		= 0x7E40
	IN2BUF		= 0x7E00
	OUT2BUF		= 0x7DC0
	IN3BUF		= 0x7D80
	OUT3BUF		= 0x7D40
	IN4BUF		= 0x7D00
	OUT4BUF		= 0x7CC0
	IN5BUF		= 0x7C80
	OUT5BUF		= 0x7C40
	IN6BUF		= 0x7C00
	OUT6BUF		= 0x7BC0
	IN7BUF		= 0x7B80
	OUT7BUF		= 0x7B40
	SETUPBUF	= 0x7FE8
	SETUPDAT	= 0x7FE8

	EP0CS		= 0x7FB4
	IN0BC		= 0x7FB5
	IN1CS		= 0x7FB6
	IN1BC		= 0x7FB7
	IN2CS		= 0x7FB8
	IN2BC		= 0x7FB9
	IN3CS		= 0x7FBA
	IN3BC		= 0x7FBB
	IN4CS		= 0x7FBC
	IN4BC		= 0x7FBD
	IN5CS		= 0x7FBE
	IN5BC		= 0x7FBF
	IN6CS		= 0x7FC0
	IN6BC		= 0x7FC1
	IN7CS		= 0x7FC2
	IN7BC		= 0x7FC3
	OUT0BC		= 0x7FC5
	OUT1CS		= 0x7FC6
	OUT1BC		= 0x7FC7
	OUT2CS		= 0x7FC8
	OUT2BC		= 0x7FC9
	OUT3CS		= 0x7FCA
	OUT3BC		= 0x7FCB
	OUT4CS		= 0x7FCC
	OUT4BC		= 0x7FCD
	OUT5CS		= 0x7FCE
	OUT5BC		= 0x7FCF
	OUT6CS		= 0x7FD0
	OUT6BC		= 0x7FD1
	OUT7CS		= 0x7FD2
	OUT7BC		= 0x7FD3

	IVEC		= 0x7FA8
	IN07IRQ		= 0x7FA9
	OUT07IRQ	= 0x7FAA
	USBIRQ		= 0x7FAB
	IN07IEN		= 0x7FAC
	OUT07IEN	= 0x7FAD
	USBIEN		= 0x7FAE
	USBBAV		= 0x7FAF
	BPADDRH		= 0x7FB2
	BPADDRL		= 0x7FB3

	SUDPTRH		= 0x7FD4
	SUDPTRL		= 0x7FD5
	USBCS		= 0x7FD6
	TOGCTL		= 0x7FD7
	USBFRAMEL	= 0x7FD8
	USBFRAMEH	= 0x7FD9
	FNADDR		= 0x7FDB
	USBPAIR		= 0x7FDD
	IN07VAL		= 0x7FDE
	OUT07VAL	= 0x7FDF
	AUTOPTRH	= 0x7FE3
	AUTOPTRL	= 0x7FE4
	AUTODATA	= 0x7FE5

	;; isochronous endpoints. only available if ISODISAB=0

	OUT8DATA	= 0x7F60
	OUT9DATA	= 0x7F61
	OUT10DATA	= 0x7F62
	OUT11DATA	= 0x7F63
	OUT12DATA	= 0x7F64
	OUT13DATA	= 0x7F65
	OUT14DATA	= 0x7F66
	OUT15DATA	= 0x7F67

	IN8DATA		= 0x7F68
	IN9DATA		= 0x7F69
	IN10DATA	= 0x7F6A
	IN11DATA	= 0x7F6B
	IN12DATA	= 0x7F6C
	IN13DATA	= 0x7F6D
	IN14DATA	= 0x7F6E
	IN15DATA	= 0x7F6F

	OUT8BCH		= 0x7F70
	OUT8BCL		= 0x7F71
	OUT9BCH		= 0x7F72
	OUT9BCL		= 0x7F73
	OUT10BCH	= 0x7F74
	OUT10BCL	= 0x7F75
	OUT11BCH	= 0x7F76
	OUT11BCL	= 0x7F77
	OUT12BCH	= 0x7F78
	OUT12BCL	= 0x7F79
	OUT13BCH	= 0x7F7A
	OUT13BCL	= 0x7F7B
	OUT14BCH	= 0x7F7C
	OUT14BCL	= 0x7F7D
	OUT15BCH	= 0x7F7E
	OUT15BCL	= 0x7F7F

	OUT8ADDR	= 0x7FF0
	OUT9ADDR	= 0x7FF1
	OUT10ADDR	= 0x7FF2
	OUT11ADDR	= 0x7FF3
	OUT12ADDR	= 0x7FF4
	OUT13ADDR	= 0x7FF5
	OUT14ADDR	= 0x7FF6
	OUT15ADDR	= 0x7FF7
	IN8ADDR		= 0x7FF8
	IN9ADDR		= 0x7FF9
	IN10ADDR	= 0x7FFA
	IN11ADDR	= 0x7FFB
	IN12ADDR	= 0x7FFC
	IN13ADDR	= 0x7FFD
	IN14ADDR	= 0x7FFE
	IN15ADDR	= 0x7FFF

	ISOERR		= 0x7FA0
	ISOCTL		= 0x7FA1
	ZBCOUNT		= 0x7FA2
	INISOVAL	= 0x7FE0
	OUTISOVAL	= 0x7FE1
	FASTXFR		= 0x7FE2

	;; CPU control registers

	CPUCS		= 0x7F92

	;; IO port control registers

	PORTACFG	= 0x7F93
	PORTBCFG	= 0x7F94
	PORTCCFG	= 0x7F95
	OUTA		= 0x7F96
	OUTB		= 0x7F97
	OUTC		= 0x7F98
	PINSA		= 0x7F99
	PINSB		= 0x7F9A
	PINSC		= 0x7F9B
	OEA		= 0x7F9C
	OEB		= 0x7F9D
	OEC		= 0x7F9E

	;; I2C controller registers

	I2CS		= 0x7FA5
	I2DAT		= 0x7FA6

	;; ISO buffer sizes
	ISO8INSIZE	= 496
	ISO8OUTSIZE	= 496
	ISO9INSIZE	= 16
	ISO9OUTSIZE	= 16

	;; -----------------------------------------------------

	.area CODE (CODE)
	ljmp	startup
	ljmp	int0_isr
	.ds	5
	ljmp	timer0_isr
	.ds	5
	ljmp	int1_isr
	.ds	5
	ljmp	timer1_isr
	.ds	5
	ljmp	ser0_isr
	.ds	5
	ljmp	timer2_isr
	.ds	5
	ljmp	resume_isr
	.ds	5
	ljmp	ser1_isr
	.ds	5
	ljmp	usb_isr
	.ds	5
	ljmp	i2c_isr
	.ds	5
	ljmp	int4_isr
	.ds	5
	ljmp	int5_isr
	.ds	5
	ljmp	int6_isr
	.ds	0x9a

usb_isr:
	ljmp	usb_sudav_isr
	.ds	1
	ljmp	usb_sof_isr
	.ds	1
	ljmp	usb_sutok_isr
	.ds	1
	ljmp	usb_suspend_isr
	.ds	1
	ljmp	usb_usbreset_isr
	.ds	1
	reti
	.ds	3
	ljmp	usb_ep0in_isr
	.ds	1
	ljmp	usb_ep0out_isr
	.ds	1
	ljmp	usb_ep1in_isr
	.ds	1
	ljmp	usb_ep1out_isr
	.ds	1
	ljmp	usb_ep2in_isr
	.ds	1
	ljmp	usb_ep2out_isr
	.ds	1
	ljmp	usb_ep3in_isr
	.ds	1
	ljmp	usb_ep3out_isr
	.ds	1
	ljmp	usb_ep4in_isr
	.ds	1
	ljmp	usb_ep4out_isr
	.ds	1
	ljmp	usb_ep5in_isr
	.ds	1
	ljmp	usb_ep5out_isr
	.ds	1
	ljmp	usb_ep6in_isr
	.ds	1
	ljmp	usb_ep6out_isr
	.ds	1
	ljmp	usb_ep7in_isr
	.ds	1
	ljmp	usb_ep7out_isr

	;; -----------------------------------------------------

	BULKCHUNKS = 32
	BULK2CHUNKS = 8

	INTERFACENR = 6

	.area	OSEG (OVR,DATA)
	.area	BSEG (BIT)


	.area	ISEG (DATA)
bcnt:		.ds	BULKCHUNKS
b2cnt:		.ds	BULK2CHUNKS
stack:		.ds	0x80-BULKCHUNKS

	.area	DSEG (DATA)
errcode:	.ds	1
errval:		.ds	1
ctrlcode:	.ds	1
ctrlcount:	.ds	2
leddiv:		.ds	1
irqcount:	.ds	1
	;; bulk variables
wrptr:		.ds	1
rdptr:		.ds	1
wrptr2:		.ds	1
rdptr2:		.ds	1
sofcount:	.ds	1
ctrlcnt:	.ds	1

	;; USB state
numconfig:	.ds	1
altsetting:	.ds	INTERFACENR
	
	.area	XSEG (DATA)
ctrlbuf:	.ds	64
bulkbuf:	.ds	BULKCHUNKS*64
bulk2buf:	.ds	BULK2CHUNKS*64


	.area	GSINIT (CODE)
startup:
	mov	sp,#stack	; -1
	clr	a
	mov	psw,a
	mov	dps,a
	;lcall	__sdcc_external_startup
	;mov	a,dpl0
	;jz	__sdcc_init_data
	;ljmp	__sdcc_program_startup
__sdcc_init_data:

	.area	GSINIT2 (CODE)
__sdcc_program_startup:
	;; assembler code startup
	clr	a
	mov	errcode,a
	mov	errval,a
	mov	rdptr,a
	mov	wrptr,a
	mov	rdptr2,a
	mov	wrptr2,a
	mov	sofcount,a
 	mov	irqcount,a
 	mov	ctrlcnt,a
	;; some indirect register setup
	mov	ckcon,#0x31	; one external wait state, to avoid chip bugs
	;; Timer setup:
	;; timer 0: LED blink    : T0M=0, CT0=0, MODE0=1
	;; timer 1: Baudrate gen : T1M=1, CT1=0, MODE1=2
	mov	tmod,#0x21
	mov	tcon,#0x55	; INT0/INT1 edge
	mov	th1,#256-156	; 1200 bauds
	mov	pcon,#0		; SMOD0=0
	;; init USB subsystem
        mov     a,#0x00
        mov     dptr,#IN8ADDR	; IN8 FIFO address
        movx    @dptr,a
        mov     a,#((ISO8INSIZE)/4)
        mov     dptr,#OUT8ADDR	; OUT8 FIFO address
        movx    @dptr,a
        mov     a,#((ISO8INSIZE+ISO8OUTSIZE)/4)
        mov     dptr,#IN9ADDR	; IN9 FIFO address
        movx    @dptr,a
        mov     a,#((ISO8INSIZE+ISO8OUTSIZE+ISO9INSIZE)/4)
        mov     dptr,#OUT9ADDR	; OUT9 FIFO address
        movx    @dptr,a
        mov     dptr,#ISOCTL
        clr     a               ; enable ISO endpoints
        movx    @dptr,a
        mov     dptr,#USBBAV
        mov     a,#1            ; enable autovector, disable breakpoint logic
        movx    @dptr,a
	mov	a,#3		; ISO ep 8 valid for input and output
	mov	dptr,#INISOVAL
	movx	@dptr,a
	mov	dptr,#OUTISOVAL
	movx	@dptr,a
	mov	dptr,#USBPAIR
	mov	a,#0x3f		; pair EP 2&3, 4&5, 6&7 for input & output
	movx	@dptr,a
	mov	dptr,#IN07VAL
	mov	a,#0x57		; enable EP0+EP1+EP2+EP4+EP6
	movx	@dptr,a
	mov	dptr,#OUT07VAL
	mov	a,#0x55		; enable EP0+EP2+EP4+EP6
	movx	@dptr,a
	;; USB:	clear endpoint toggles
	mov	dptr,#TOGCTL
	mov	r7,#7		; clear endpoint toggles 1-7
10$:	mov	a,r7
	orl	a,#0x10
	movx	@dptr,a
	orl	a,#0x30
	movx	@dptr,a		; clear EP r7 in toggle
	mov	a,r7
	movx	@dptr,a
	orl	a,#0x20
	movx	@dptr,a		; clear EP r7 out toggle
	djnz	r7,10$
	;; configure IO ports
	mov	dptr,#PORTACFG
	mov	a,#0
	movx	@dptr,a
	mov	dptr,#OUTA
	mov	a,#0x82		; set PROG hi
	movx	@dptr,a
	mov	dptr,#OEA
	mov	a,#0xc2		; out: TMS,TDI,PROG  in: DONE
	movx	@dptr,a
	mov	dptr,#PORTBCFG
	mov	a,#0
	movx	@dptr,a
	mov	dptr,#OEB
	mov	a,#0
	movx	@dptr,a
	mov	dptr,#PORTCCFG
	mov	a,#0xc3		; RD/WR/TXD0/RXD0 are special function pins
	movx	@dptr,a
	mov	dptr,#OUTC
	mov	a,#0x20
	movx	@dptr,a
	mov	dptr,#OEC
	mov	a,#0x2a		; out: LEDCON,LEDSTA,TCK  in: TDO,INIT
	movx	@dptr,a
	;; enable interrupts
	mov	ie,#0x82	; enable timer 0 int
	mov	eie,#0x01	; enable USB interrupts
	mov	dptr,#USBIEN
	mov	a,#1		; enable SUDAV interrupt
	movx	@dptr,a
	mov	dptr,#IN07IEN
	mov	a,#3		; enable EP0+EP1 interrupt
	movx	@dptr,a
	mov	dptr,#OUT07IEN
	mov	a,#1		; enable EP0 interrupt
	movx	@dptr,a

	;; initialize USB state
	clr	a
	mov	numconfig,a
	mov	r0,#altsetting
	mov	r2,#INTERFACENR
3$:	mov	@r0,a
	inc	r0
	djnz	r2,3$
	;; give Windows a chance to finish the writecpucs control transfer
	;; 10ms delay loop
	mov	dptr,#-6020
2$:	inc	dptr		; 3 cycles
	mov	a,dpl0		; 2 cycles
	orl	a,dph0		; 2 cycles
	jnz	2$		; 3 cycles
	.if	1
	;; disconnect from USB bus
	mov	dptr,#USBCS
	clr	a
	movx	@dptr,a
	;; wait 1 sec
	;mov	r2,#100
	mov	r2,#30
	;; 10ms delay loop
0$:	mov	dptr,#-6000
1$:	inc	dptr            ; 3 cycles
	mov	a,dpl0          ; 2 cycles
	orl	a,dph0          ; 2 cycles
	jnz	1$              ; 3 cycles
	djnz	r2,0$
	;; reconnect to USB bus
	mov	dptr,#USBCS
	mov	a,#2		; 8051 handles control
	movx	@dptr,a
	mov	a,#6		; reconnect, 8051 handles control
	movx	@dptr,a
	.endif

	;; final
	lcall	fillusbintr
	;; arm EP2 out
	mov	dptr,#OUT2BC
	movx	@dptr,a
	;; arm EP4 out
	mov	dptr,#OUT4BC
	movx	@dptr,a
	;; arm EP6 out
	mov	dptr,#OUT6BC
	movx	@dptr,a
	;; clear pending SOF interrupt
	mov	dptr,#USBIRQ
	mov	a,#2
	movx	@dptr,a
	;; enable SOFIR interrupt
	mov	dptr,#USBIEN
	mov	a,#3		; enable SUDAV+SOFIR interrupt
	movx	@dptr,a
	ljmp	mainloop

	.area	CSEG (CODE)
	ar2 = 0x02
	ar3 = 0x03
	ar4 = 0x04
	ar5 = 0x05
	ar6 = 0x06
	ar7 = 0x07
	ar0 = 0x00
	ar1 = 0x01

mainloop:
	;; check for EP2 out
	mov	dptr,#OUT2CS
	movx	a,@dptr
	jb	acc.1,ep2outbusy
	mov	a,rdptr
	setb	c
	subb	a,wrptr
	anl	a,#(BULKCHUNKS-1)
	jz	ep2outbusy
	mov	dps,#1
	mov	a,wrptr
	rr	a
	rr	a
	mov	dpl0,a
	anl	a,#0xc0
	add	a,#<bulkbuf
	xch	a,dpl0
	anl	a,#0x3f
	addc	a,#>bulkbuf
	mov	dph0,a
	mov	a,wrptr
	add	a,#bcnt
	mov	r0,a
	mov	r1,#64
	mov	dptr,#OUT2BUF
0$:	movx	a,@dptr
	inc	dptr
	dec	dps
	movx	@dptr,a
	inc	dptr
	inc	dps
	djnz	r1,0$
	mov	dptr,#OUT2BC
	movx	a,@dptr
	mov	@r0,a
	movx	@dptr,a		; arm EP2out
	mov	a,wrptr
	inc	a
	anl	a,#(BULKCHUNKS-1)
	mov	wrptr,a
ep2outbusy:
	;; check for EP2 in
	mov	dptr,#IN2CS
	movx	a,@dptr
	jb	acc.1,ep2inbusy
	mov	a,rdptr
	clr	c
	subb	a,wrptr
	anl	a,#(BULKCHUNKS-1)
	jz	ep2inbusy
	mov	dps,#1
	mov	dptr,#IN2BUF
	dec	dps
	mov	a,rdptr
	rr	a
	rr	a
	mov	dpl0,a
	anl	a,#0xc0
	add	a,#<bulkbuf
	xch	a,dpl0
	anl	a,#0x3f
	addc	a,#>bulkbuf
	mov	dph0,a
	mov	a,rdptr
	add	a,#bcnt
	mov	r0,a
	mov	r1,#64
0$:	movx	a,@dptr
	inc	dptr
	inc	dps
	movx	@dptr,a
	inc	dptr
	dec	dps
	djnz	r1,0$
	mov	dptr,#IN2BC
	mov	a,@r0
	movx	@dptr,a
	mov	a,rdptr
	inc	a
	anl	a,#(BULKCHUNKS-1)
	mov	rdptr,a
ep2inbusy:
	;; check for EP4 out
	mov	dptr,#OUT4CS
	movx	a,@dptr
	jb	acc.1,ep4outbusy
	mov	a,rdptr2
	setb	c
	subb	a,wrptr2
	anl	a,#(BULK2CHUNKS-1)
	jz	ep4outbusy
	mov	dps,#1
	mov	a,wrptr2
	rr	a
	rr	a
	mov	dpl0,a
	anl	a,#0xc0
	add	a,#<bulk2buf
	xch	a,dpl0
	anl	a,#0x3f
	addc	a,#>bulk2buf
	mov	dph0,a
	mov	a,wrptr2
	add	a,#b2cnt
	mov	r0,a
	mov	r1,#64
	mov	dptr,#OUT4BUF
0$:	movx	a,@dptr
	inc	dptr
	dec	dps
	movx	@dptr,a
	inc	dptr
	inc	dps
	djnz	r1,0$
	mov	dptr,#OUT4BC
	movx	a,@dptr
	mov	@r0,a
	movx	@dptr,a		; arm EP2out
	mov	a,wrptr2
	inc	a
	anl	a,#(BULK2CHUNKS-1)
	mov	wrptr2,a
ep4outbusy:
	;; check for EP4 in
	mov	dptr,#IN4CS
	movx	a,@dptr
	jb	acc.1,ep4inbusy
	mov	a,rdptr2
	clr	c
	subb	a,wrptr2
	anl	a,#(BULK2CHUNKS-1)
	jz	ep4inbusy
	mov	dps,#1
	mov	dptr,#IN4BUF
	dec	dps
	mov	a,rdptr2
	rr	a
	rr	a
	mov	dpl0,a
	anl	a,#0xc0
	add	a,#<bulk2buf
	xch	a,dpl0
	anl	a,#0x3f
	addc	a,#>bulk2buf
	mov	dph0,a
	mov	a,rdptr2
	add	a,#b2cnt
	mov	r0,a
	mov	r1,#64
0$:	movx	a,@dptr
	inc	dptr
	inc	dps
	movx	@dptr,a
	inc	dptr
	dec	dps
	djnz	r1,0$
	mov	dptr,#IN4BC
	mov	a,@r0
	movx	@dptr,a
	mov	a,rdptr2
	inc	a
	anl	a,#(BULK2CHUNKS-1)
	mov	rdptr2,a
ep4inbusy:
	;; check for EP6 out
	mov	dptr,#OUT6CS
	movx	a,@dptr
	jb	acc.1,ep6busy
	;; check for EP6 in
	mov	dptr,#IN6CS
	movx	a,@dptr
	jb	acc.1,ep6busy
	mov	dps,#1
	mov	dptr,#IN6BUF
	dec	dps
	mov	dptr,#OUT6BUF
	mov	r0,#64
0$:	movx	a,@dptr
	inc	dptr
	inc	dps
	movx	@dptr,a
	inc	dptr
	dec	dps
	djnz	r0,0$
	mov	dptr,#OUT6BC
	movx	a,@dptr
	movx	@dptr,a		; arm EP6 out
	mov	dptr,#IN6BC
	movx	@dptr,a
ep6busy:
	ljmp	mainloop


	;; ------------------ interrupt handlers ------------------------

int0_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	tcon+1
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

timer0_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	tcon+5
	;; handle interrupt
	inc	leddiv
	mov	a,leddiv
	anl	a,#7
	jnz	0$
	mov	dptr,#OUTC
	movx	a,@dptr
	xrl	a,#0x08
	movx	@dptr,a
0$:
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

int1_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	tcon+3
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

timer1_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	tcon+7
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

ser0_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	scon0+0
	clr	scon0+1
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

timer2_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	t2con+7
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

resume_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	eicon+4
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

ser1_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	scon1+0
	clr	scon1+1
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

i2c_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.5
	mov	exif,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

int4_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.6
	mov	exif,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

int5_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.7
	mov	exif,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

int6_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	clr	eicon+3
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_sudav_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	dpl1
	push	dph1
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	push	ar0
	push	ar7
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#USBIRQ
	mov	a,#0x01
	movx	@dptr,a
	;; handle interrupt
	mov	ctrlcode,#0		; reset control out code
	mov	dptr,#SETUPDAT+1
	movx	a,@dptr			; bRequest field
	;; standard commands
	;; USB_REQ_GET_DESCRIPTOR
	cjne	a,#USB_REQ_GET_DESCRIPTOR,cmdnotgetdesc
	mov	dptr,#SETUPDAT		; bRequestType == 0x80
	movx	a,@dptr
	cjne	a,#USB_DIR_IN,setupstallstd
	mov	dptr,#SETUPDAT+3
	movx	a,@dptr
	cjne	a,#USB_DT_DEVICE,cmdnotgetdescdev
	mov	dptr,#SUDPTRH
	mov	a,#>devicedescr
	movx	@dptr,a
	inc	dptr
	mov	a,#<devicedescr
	movx	@dptr,a
	sjmp	setupackstd
cmdnotgetdescdev:
	cjne	a,#USB_DT_CONFIG,cmdnotgetdesccfg
	mov	dptr,#SETUPDAT+2
	movx	a,@dptr
	jnz	setupstallstd
	mov	dptr,#SUDPTRH
	mov	a,#>config0descr
	movx	@dptr,a
	inc	dptr
	mov	a,#<config0descr
	movx	@dptr,a
	sjmp	setupackstd
cmdnotgetdesccfg:
	cjne	a,#USB_DT_STRING,setupstallstd
	mov	dptr,#SETUPDAT+2
	movx	a,@dptr
	add	a,#-numstrings
	jc	setupstallstd
	movx	a,@dptr
	add	a,acc
	add	a,#<stringdescr
	mov	dpl0,a
	clr	a
	addc	a,#>stringdescr
	mov	dph0,a
	movx	a,@dptr
	mov	b,a
	inc	dptr
	movx	a,@dptr
	mov	dptr,#SUDPTRH
	movx	@dptr,a
	inc	dptr
	mov	a,b
	movx	@dptr,a
	; sjmp	setupackstd	
setupackstd:
	ljmp	setupack
setupstallstd:
	ljmp	setupstall
cmdnotgetdesc:
	;; USB_REQ_SET_CONFIGURATION
	cjne	a,#USB_REQ_SET_CONFIGURATION,cmdnotsetconf
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	jnz	setupstallstd
	mov	dptr,#SETUPDAT+2
	movx	a,@dptr
	add	a,#-2
	jc	setupstallstd
	movx	a,@dptr
	mov	numconfig,a
cmdresettoggleshalt:
	mov	dptr,#TOGCTL
	mov	r0,#7
0$:	mov	a,r0
	orl	a,#0x10
	movx	@dptr,a
	orl	a,#0x30
	movx	@dptr,a
	mov	a,r0
	movx	@dptr,a
	orl	a,#0x20
	movx	@dptr,a
	djnz	r0,0$
	clr	a
	movx	@dptr,a
	mov	a,#2
	mov	dptr,#IN1CS
	mov	r0,#7
1$:	movx	@dptr,a
	inc	dptr
	inc	dptr
	djnz	r0,1$
	mov	dptr,#OUT1CS
	mov	r0,#7
2$:	movx	@dptr,a
	inc	dptr
	inc	dptr
	djnz	r0,2$
	lcall	fillusbintr
	sjmp	setupackstd
cmdnotsetconf:
	;; USB_REQ_SET_INTERFACE
	cjne	a,#USB_REQ_SET_INTERFACE,cmdnotsetint
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	cjne	a,#USB_RECIP_INTERFACE|USB_DIR_OUT,setupstallstd
	mov	a,numconfig
	cjne	a,#1,setupstallstd
	mov	dptr,#SETUPDAT+4	; wIndex (interface)
	movx	a,@dptr
	add	a,#(-INTERFACENR)
	jc	setupstallstd
	add	a,#(INTERFACENR+altsetting)
	mov	r0,a
	mov	dptr,#SETUPDAT+2	; wValue (altsetting)
	movx	a,@dptr
	mov	@r0,a
	sjmp	cmdresettoggleshalt
cmdnotsetint:
	;; USB_REQ_GET_INTERFACE
	cjne	a,#USB_REQ_GET_INTERFACE,cmdnotgetint
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	cjne	a,#USB_RECIP_INTERFACE|USB_DIR_IN,setupstallstd
	mov	a,numconfig
	cjne	a,#1,setupstallstd
	mov	dptr,#SETUPDAT+4	; wIndex (interface)
	movx	a,@dptr
	add	a,#(-INTERFACENR)
	jc	setupstallstd
	add	a,#(INTERFACENR+altsetting)
	mov	r0,a
	mov	a,@r0
cmdrespondonebyte:
	mov	dptr,#IN0BUF
	movx	@dptr,a
	mov	dptr,#IN0BC
	mov	a,#1
	movx	@dptr,a	
	sjmp	setupackstd2
cmdnotgetint:
	;; USB_REQ_GET_CONFIGURATION
	cjne	a,#USB_REQ_GET_CONFIGURATION,cmdnotgetconf
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	cjne	a,#USB_RECIP_DEVICE|USB_DIR_IN,setupstallstd2
	mov	a,numconfig
	sjmp	cmdrespondonebyte	
cmdnotgetconf:
	;; USB_REQ_GET_STATUS (0)
	jnz	cmdnotgetstat
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	cjne	a,#USB_RECIP_DEVICE|USB_DIR_IN,cmdnotgetstatdev
	mov	a,#1
cmdrespondstat:
	mov	dptr,#IN0BUF
	movx	@dptr,a
	inc	dptr
	clr	a
	movx	@dptr,a
	mov	dptr,#IN0BC
	mov	a,#2
	movx	@dptr,a	
	sjmp	setupackstd2
cmdnotgetstatdev:
	cjne	a,#USB_RECIP_INTERFACE|USB_DIR_IN,cmdnotgetstatintf
	clr	a
	sjmp	cmdrespondstat
cmdnotgetstatintf:
	cjne	a,#USB_RECIP_ENDPOINT|USB_DIR_IN,setupstallstd2
	mov	dptr,#SETUPDAT+4
	movx	a,@dptr
	mov	dptr,#OUT1CS-2
	jnb	acc.7,0$
	mov	dptr,#IN1CS-2
0$:	anl	a,#15
	jz	setupstallstd2
	jb	acc.3,setupstallstd2
	add	a,acc
	add	a,dpl0
	mov	dpl0,a
	movx	a,@dptr
	sjmp	cmdrespondstat
setupackstd2:
	ljmp	setupack
setupstallstd2:
	ljmp	setupstall
cmdnotgetstat:
	;; USB_REQ_SET_FEATURE
	cjne	a,#USB_REQ_SET_FEATURE,cmdnotsetftr
	mov	b,#1
	sjmp	handleftr
cmdnotsetftr:
	;; USB_REQ_CLEAR_FEATURE
	cjne	a,#USB_REQ_CLEAR_FEATURE,cmdnotclrftr
	mov	b,#0
handleftr:
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	cjne	a,#USB_RECIP_ENDPOINT|USB_DIR_OUT,setupstallstd2
	inc	dptr
	inc	dptr
	movx	a,@dptr
	jnz	setupstallstd2	; not ENDPOINT_HALT feature
	inc	dptr
	movx	a,@dptr
	jnz	setupstallstd2
	inc	dptr
	movx	a,@dptr
	mov	dptr,#OUT1CS-2
	jnb	acc.7,0$
	mov	dptr,#IN1CS-2
	orl	a,#0x10
0$:	jb	acc.3,setupstallstd2
	;; clear data toggle
	anl	a,#0x1f
	inc	dps
	mov	dptr,#TOGCTL
	movx	@dptr,a
	orl	a,#0x20
	movx	@dptr,a
	anl	a,#15
	movx	@dptr,a
	dec	dps	
	;; clear/set ep halt feature
	add	a,acc
	add	a,dpl0
	mov	dpl0,a
	mov	a,b
	movx	@dptr,a
	sjmp	setupackstd2
cmdnotclrftr:
	;; vendor specific commands
	;; 0xe0
	cjne	a,#0xe0,cmdnote0
	mov	dptr,#SETUPDAT
	movx	a,@dptr
	cjne	a,#USB_RECIP_DEVICE|USB_TYPE_VENDOR|USB_DIR_IN,cmde0notc0	; bRequestType == 0xc0
	mov	dptr,#IN0BUF
	mov	a,ctrlcnt
	jz	0$
	inc	dps
	mov	dptr,#ctrlbuf
	mov	r0,a
	mov	r7,a
1$:	movx	a,@dptr
	inc	dptr
	dec	dps
	movx	@dptr,a
	inc	dptr
	inc	dps
	djnz	r7,1$
	dec	dps
	mov	a,r0
0$:	mov	dptr,#IN0BC
	movx	@dptr,a
	ljmp	setupack
cmde0notc0:
	cjne	a,#USB_RECIP_DEVICE|USB_TYPE_VENDOR|USB_DIR_OUT,setupstalle0	; bRequestType == 0x40
	mov	dptr,#(SETUPDAT+6)	; wLength <= 0x40
	movx	a,@dptr
	add	a,#(256-0x41)
	jc	setupstalle0
	inc	dptr
	movx	a,@dptr
	jnz	setupstalle0
	mov	ctrlcode,#1
	mov	dptr,#OUT0BC
	movx	@dptr,a
	ljmp	endsetup
cmdnote0:
	;;	0xe1
	cjne	a,#0xe1,cmdnote1
	mov	dptr,#SETUPDAT		; bRequestType == 0xc0
	movx	a,@dptr
	cjne	a,#USB_RECIP_DEVICE|USB_TYPE_VENDOR|USB_DIR_IN,setupstall
	mov	dptr,#IN0BUF
	mov	a,wrptr
	clr	c
	subb	a,rdptr
	anl	a,#(BULKCHUNKS-1)
	movx	@dptr,a
	inc	dptr
	mov	a,wrptr2
	clr	c
	subb	a,rdptr2
	anl	a,#(BULK2CHUNKS-1)
	movx	@dptr,a
	inc	dptr
	mov	a,irqcount
	movx	@dptr,a
	inc	dptr
	mov	a,sofcount
	movx	@dptr,a
	inc	dptr
	mov	a,ctrlcnt
	movx	@dptr,a
	inc	dptr
	mov	a,leddiv
	movx	@dptr,a
	mov	a,#6
	mov	dptr,#IN0BC
	movx	@dptr,a
	sjmp	setupack
setupstalle0:
	ljmp	setupstall
cmdnote1:
	;;	0xe2
	cjne	a,#0xe2,cmdnote2
	mov	dptr,#SETUPDAT		; bRequestType == 0xc2 (vendor ep)
	movx	a,@dptr
	cjne	a,#USB_RECIP_ENDPOINT|USB_TYPE_VENDOR|USB_DIR_IN,setupstall
	mov	dptr,#(SETUPDAT+4)	; wIndex
	movx	a,@dptr
	cjne	a,#0x02,cmde1notep2
	clr	a
	mov	rdptr,a
	mov	wrptr,a
	mov	dptr,#IN2CS
	mov	a,#0x02
	movx	@dptr,a			; clear BSY
	mov	dptr,#OUT2BC
	movx	@dptr,a			; set BSY
	sjmp	cmdrespondnullmsg
cmde1notep2:
	cjne	a,#0x04,cmde1notep4
	clr	a
	mov	rdptr2,a
	mov	wrptr2,a
	mov	dptr,#IN4CS
	mov	a,#0x02
	movx	@dptr,a			; clear BSY
	mov	dptr,#OUT4BC
	movx	@dptr,a			; set BSY
	sjmp	cmdrespondnullmsg
cmde1notep4:
	cjne	a,#0x06,setupstall
	mov	dptr,#IN6CS
	mov	a,#0x02
	movx	@dptr,a			; clear BSY
	mov	dptr,#OUT6BC
	movx	@dptr,a			; set BSY
cmdrespondnullmsg:
	clr	a
	mov	dptr,#IN0BC
	movx	@dptr,a
	sjmp	setupack
cmdnote2:
	;; unknown commands fall through to setupstall

setupstall:
	mov	a,#3
	sjmp	endsetup
setupack:
	mov	a,#2
endsetup:
	mov	dptr,#EP0CS
	movx	@dptr,a
endusbisr:
	;; epilogue
	pop	ar7
	pop	ar0
	pop	dps
	pop	psw
	pop	dph1
	pop	dpl1
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_sof_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	dpl1
	push	dph1
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	push	ar0
	push	ar1
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#USBIRQ
	mov	a,#0x02
	movx	@dptr,a
	;; handle interrupt
	inc	sofcount
	;; copy ISO data from input to output
	mov	dptr,#ISOERR
	movx	a,@dptr
	jb	acc.0,isoouterr8
	mov	dptr,#OUT8BCH
	movx	a,@dptr
	anl	a,#3
	mov	r0,a
	mov	dptr,#OUT8BCL
	movx	a,@dptr
	mov	r1,a
	mov	dptr,#OUT8DATA
	inc	dps
	mov	dptr,#IN8DATA
	dec	dps
	jz	0$
1$:	movx	a,@dptr
	inc	dps
	movx	@dptr,a
	dec	dps
	djnz	r1,1$
0$:	mov	a,r0
	jz	2$
3$:	mov	r1,#0
4$:	movx	a,@dptr
	inc	dps
	movx	@dptr,a
	dec	dps
	djnz	r1,4$
	djnz	r0,3$
2$:
	mov	dptr,#ISOERR
	movx	a,@dptr
isoouterr8:
	jb	acc.1,isoouterr9
	mov	dptr,#OUT9BCH
	movx	a,@dptr
	anl	a,#3
	mov	r0,a
	mov	dptr,#OUT9BCL
	movx	a,@dptr
	mov	r1,a
	mov	dptr,#OUT9DATA
	inc	dps
	mov	dptr,#IN9DATA
	dec	dps
	jz	0$
1$:	movx	a,@dptr
	inc	dps
	movx	@dptr,a
	dec	dps
	djnz	r1,1$
0$:	mov	a,r0
	jz	2$
3$:	mov	r1,#0
4$:	movx	a,@dptr
	inc	dps
	movx	@dptr,a
	dec	dps
	djnz	r1,4$
	djnz	r0,3$
2$:
isoouterr9:
	;; epilogue
	pop	ar1
	pop	ar0
	pop	dps
	pop	psw
	pop	dph1
	pop	dpl1
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti


usb_sutok_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#USBIRQ
	mov	a,#0x04
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_suspend_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#USBIRQ
	mov	a,#0x08
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_usbreset_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#USBIRQ
	mov	a,#0x10
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep0in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	dpl1
	push	dph1
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	push	ar0
	push	ar7
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x01
	movx	@dptr,a
	;; handle interrupt
	mov	a,ctrlcode
	mov	ctrlcode,#0
	cjne	a,#255,ep0install

	mov	dptr,#IN0BC
	clr	a
	movx	@dptr,a
	sjmp	ep0inack

ep0install:
	mov	a,#3
	sjmp	ep0incs
ep0inack:
	mov	a,#2
ep0incs:
	mov	dptr,#EP0CS
	movx	@dptr,a
ep0inendisr:
	;; epilogue
	pop	ar7
	pop	ar0
	pop	dps
	pop	psw
	pop	dph1
	pop	dpl1
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep0out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	dpl1
	push	dph1
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	push	ar0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x01
	movx	@dptr,a
	;; handle interrupt
	mov	a,ctrlcode		; check control code
	cjne	a,#0x01,ep0outstall
	mov	ctrlcode,#0
	mov	dptr,#OUT0BC
	movx	a,@dptr
	mov	ctrlcnt,a
	jz	0$
	mov	dptr,#ctrlbuf
	inc	dps
	mov	dptr,#OUT0BUF
	mov	r0,a
1$:	movx	a,@dptr
	inc	dptr
	dec	dps
	movx	@dptr,a
	inc	dptr
	inc	dps
	djnz	r7,1$
	dec	dps
0$:	
	sjmp	ep0outack

ep0outstall:
	mov	ctrlcode,#0
	mov	a,#3
	sjmp	ep0outcs
ep0outack:
	mov	ctrlcode,#0
	mov	a,#2
ep0outcs:
	mov	dptr,#EP0CS
	movx	@dptr,a
ep0outendisr:
	;; epilogue
	pop	ar0
	pop	dps
	pop	psw
	pop	dph1
	pop	dpl1
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

fillusbintr::
	; counter
	inc	irqcount
	mov	dptr,#IN1BUF
	mov	a,wrptr
	clr	c
	subb	a,rdptr
	anl	a,#(BULKCHUNKS-1)
	movx	@dptr,a
	inc	dptr
	mov	a,wrptr2
	clr	c
	subb	a,rdptr2
	anl	a,#(BULK2CHUNKS-1)
	movx	@dptr,a
	inc	dptr
	mov	a,irqcount
	movx	@dptr,a
	inc	dptr
	mov	a,sofcount
	movx	@dptr,a
	inc	dptr
	mov	a,ctrlcnt
	movx	@dptr,a
	inc	dptr
	mov	a,leddiv
	movx	@dptr,a
	; set length
	mov	dptr,#IN1BC
	mov	a,#6
	movx	@dptr,a
	ret

usb_ep1in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x02
	movx	@dptr,a
	;; handle interrupt
	lcall	fillusbintr
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep1out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x02
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep2in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x04
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep2out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x04
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep3in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x08
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep3out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x08
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep4in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x10
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep4out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x10
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep5in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x20
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep5out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x20
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep6in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x40
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep6out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x40
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep7in_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#IN07IRQ
	mov	a,#0x80
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti

usb_ep7out_isr:
	push	acc
	push	b
	push	dpl0
	push	dph0
	push	psw
	mov	psw,#0x00
	push	dps
	mov	dps,#0
	;; clear interrupt
	mov	a,exif
	clr	acc.4
	mov	exif,a
	mov	dptr,#OUT07IRQ
	mov	a,#0x80
	movx	@dptr,a
	;; handle interrupt
	;; epilogue
	pop	dps
	pop	psw
	pop	dph0
	pop	dpl0
	pop	b
	pop	acc
	reti
	
	;; -----------------------------------------------------
	;; USB descriptors
	;; -----------------------------------------------------

	;; Device and/or Interface Class codes
	USB_CLASS_PER_INTERFACE         = 0
	USB_CLASS_AUDIO                 = 1
	USB_CLASS_COMM                  = 2
	USB_CLASS_HID                   = 3
	USB_CLASS_PRINTER               = 7
	USB_CLASS_MASS_STORAGE          = 8
	USB_CLASS_HUB                   = 9
	USB_CLASS_VENDOR_SPEC           = 0xff

	;; Descriptor types
	USB_DT_DEVICE                   = 0x01
	USB_DT_CONFIG                   = 0x02
	USB_DT_STRING                   = 0x03
	USB_DT_INTERFACE                = 0x04
	USB_DT_ENDPOINT                 = 0x05

	;; Standard requests
	USB_REQ_GET_STATUS              = 0x00
	USB_REQ_CLEAR_FEATURE           = 0x01
	USB_REQ_SET_FEATURE             = 0x03
	USB_REQ_SET_ADDRESS             = 0x05
	USB_REQ_GET_DESCRIPTOR          = 0x06
	USB_REQ_SET_DESCRIPTOR          = 0x07
	USB_REQ_GET_CONFIGURATION       = 0x08
	USB_REQ_SET_CONFIGURATION       = 0x09
	USB_REQ_GET_INTERFACE           = 0x0A
	USB_REQ_SET_INTERFACE           = 0x0B
	USB_REQ_SYNCH_FRAME             = 0x0C

	;; USB Request Type and Endpoint Directions
	USB_DIR_OUT                     = 0
	USB_DIR_IN                      = 0x80

	USB_TYPE_STANDARD               = (0x00 << 5)
	USB_TYPE_CLASS                  = (0x01 << 5)
	USB_TYPE_VENDOR                 = (0x02 << 5)
	USB_TYPE_RESERVED               = (0x03 << 5)

	USB_RECIP_DEVICE                = 0x00
	USB_RECIP_INTERFACE             = 0x01
	USB_RECIP_ENDPOINT              = 0x02
	USB_RECIP_OTHER                 = 0x03

	;; Request target types.
	USB_RT_DEVICE                   = 0x00
	USB_RT_INTERFACE                = 0x01
	USB_RT_ENDPOINT                 = 0x02

	VENDID	= 0x1234
	PRODID	= 0x5678

devicedescr:
	.db	18			; bLength
	.db	USB_DT_DEVICE		; bDescriptorType
	.db	0x00, 0x01		; bcdUSB
	.db	USB_CLASS_VENDOR_SPEC	; bDeviceClass
	.db	0			; bDeviceSubClass
	.db	0xff			; bDeviceProtocol
	.db	0x40			; bMaxPacketSize0
	.db	<VENDID,>VENDID		; idVendor
	.db	<PRODID,>PRODID		; idProduct
	.db	0x02,0x00		; bcdDevice
	.db	1			; iManufacturer
	.db	2			; iProduct
	.db	3			; iSerialNumber
	.db	1			; bNumConfigurations

config0descr:
	.db	9			; bLength
	.db	USB_DT_CONFIG		; bDescriptorType
	.db	<config0sz,>config0sz	; wTotalLength
	.db	6			; bNumInterfaces
	.db	1			; bConfigurationValue
	.db	0			; iConfiguration
	.db	0b01000000		; bmAttributs (self powered)
	.db	100			; MaxPower (mA/2)
	;; interface descriptor I0:A0
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	0			; bInterfaceNumber
	.db	0			; bAlternateSetting
	.db	1			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I0:A0:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 1)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; interface descriptor I0:A1
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	0			; bInterfaceNumber
	.db	1			; bAlternateSetting
	.db	1			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I0:A1:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 1)	; bEndpointAddress
	.db	0x03			; bmAttributes (interrupt)
	.db	0x40,0x00		; wMaxPacketSize
	.db	10			; bInterval
	;; interface descriptor I1:A0
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	1			; bInterfaceNumber
	.db	0			; bAlternateSetting
	.db	2			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I1:A0:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 2)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; endpoint descriptor I1:A0:E1
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_OUT | 2)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; interface descriptor I2:A0
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	2			; bInterfaceNumber
	.db	0			; bAlternateSetting
	.db	2			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I2:A0:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 4)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; endpoint descriptor I2:A0:E1
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_OUT | 4)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; interface descriptor I3:A0
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	3			; bInterfaceNumber
	.db	0			; bAlternateSetting
	.db	2			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I3:A0:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 6)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; endpoint descriptor I3:A0:E1
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_OUT | 6)	; bEndpointAddress
	.db	0x02			; bmAttributes (bulk)
	.db	0x40,0x00		; wMaxPacketSize
	.db	0			; bInterval
	;; interface descriptor I4:A0
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	4			; bInterfaceNumber
	.db	0			; bAlternateSetting
	.db	0			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; interface descriptor I4:A1
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	4			; bInterfaceNumber
	.db	1			; bAlternateSetting
	.db	2			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I4:A1:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 8)	; bEndpointAddress
	.db	0x01			; bmAttributes (isoc)
	.db	<ISO8INSIZE,>ISO8INSIZE	; wMaxPacketSize
	.db	1			; bInterval
	;; endpoint descriptor I4:A1:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_OUT | 8)	; bEndpointAddress
	.db	0x01			; bmAttributes (isoc)
	.db	<ISO8OUTSIZE,>ISO8OUTSIZE ; wMaxPacketSize
	.db	1			; bInterval
	;; interface descriptor I5:A0
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	5			; bInterfaceNumber
	.db	0			; bAlternateSetting
	.db	0			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; interface descriptor I5:A1
	.db	9			; bLength
	.db	USB_DT_INTERFACE	; bDescriptorType
	.db	5			; bInterfaceNumber
	.db	1			; bAlternateSetting
	.db	2			; bNumEndpoints
	.db	0xff			; bInterfaceClass (vendor specific)
	.db	0x00			; bInterfaceSubClass
	.db	0xff			; bInterfaceProtocol (vendor specific)
	.db	0			; iInterface
	;; endpoint descriptor I5:A1:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_IN | 9)	; bEndpointAddress
	.db	0x01			; bmAttributes (isoc)
	.db	<ISO9INSIZE,>ISO9INSIZE	; wMaxPacketSize
	.db	1			; bInterval
	;; endpoint descriptor I5:A1:E0
	.db	7			; bLength
	.db	USB_DT_ENDPOINT		; bDescriptorType
	.db	(USB_DIR_OUT | 9)	; bEndpointAddress
	.db	0x01			; bmAttributes (isoc)
	.db	<ISO9OUTSIZE,>ISO9OUTSIZE ; wMaxPacketSize
	.db	1			; bInterval

config0sz = . - config0descr

stringdescr:
	.db	<string0,>string0
	.db	<string1,>string1
	.db	<string2,>string2
	.db	<string3,>string3

numstrings = (. - stringdescr)/2

string0:
	.db	string0sz		; bLength
	.db	USB_DT_STRING		; bDescriptorType
	.db	0,0			; LANGID[0]: Lang Neutral
string0sz = . - string0

string1:
	.db	string1sz		; bLength
	.db	USB_DT_STRING		; bDescriptorType
	.db	'T,0,'h,0,'o,0,'m,0,'a,0,'s,0,' ,0,'S,0,'a,0,'i,0,'l,0,'e,0,'r,0
string1sz = . - string1

string2:
	.db	string2sz		; bLength
	.db	USB_DT_STRING		; bDescriptorType
	.db	'U,0,'S,0,'B,0,' ,0,'S,0,'t,0,'r,0,'e,0,'s,0,'s,0,'t,0,'e,0,'s,0,'t,0
string2sz = . - string2

string3:
	.db	string3sz		; bLength
	.db	USB_DT_STRING		; bDescriptorType
	.db	'0,0,'0,0,'0,0,'0,0,'0,0,'1,0
string3sz = . - string3
