#include <linux/module.h>
#include <linux/config.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/mm.h>
#include <linux/smp_lock.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <asm/uaccess.h>
#include <linux/malloc.h>
#include <linux/videodev.h>
#include <linux/frontend.h>
#include <linux/mpd_tuner.h>
#include <asm/vr41xx.h>
#include <mmac/types.h>
#include <mmac/rtos.h>
#include <mmac/demod.h>


/* 
*   Open-method for the dummy Device 
*   Malloc memory for the first call
*/


int
dummy_open(struct video_device *dev,int mode)
{
    int result;
    printk("dummy_open\n");   
    MMAC_DEMOD_Initialise();
    return 0;
}


/*
*  dummy_ioctl handle all commands
*/

static void gain()
{
	printk("signal gain\n");
}
static void loss()
{
	printk("signal loss\n");
}
static int
dummy_ioctl(struct video_device *dev ,
		 unsigned int cmd, void *argp)
{
	MMAC_DEMOD_PARAMS p;
	MMAC_DEMOD_WRITE_IOPB params = { MMAC_DEMOD_0 };
	int result;
    printk("dummy_ioctl \n");
     return 0;
}


int
dummy_write(struct video_device *dev, char *buf, int count,int noblock)
{
  	return -1;
}

int
dummy_read(struct video_device *dev, char *buf, int count, int noblock)
{
	return -1;
}

#ifdef OLD
#define __exit
#endif


void dummy_close(struct video_device *dev )
{
    MMAC_DEMOD_CLOSE_IOPB close_param;
    int result;
    printk("dummy_close \n");
    return 0;
}

int dummy_init_done(struct video_device *vdev)
{
    UI32    msgSize;
    UI32    result;
    printk("dummy_initialize\n");
    return 0;
}

/* template for video_device-structure */
static struct video_device dvb_template = {
name:	        "TUNER",
type:	        VID_TYPE_TUNER,		
hardware:       0,
open:           dummy_open,
close:          dummy_close,
read:           NULL,
write:	        dummy_write,		
poll:	        NULL,
ioctl: 	        dummy_ioctl,
mmap:	        NULL,
initialize:	dummy_init_done,
priv:   	NULL,
busy:           0,
minor:          0
};

int __init
dummy_init(void)
{
	int result,
	  i;
printk("dummy_init\n");
   if( 0 > (video_register_device(&dvb_template, VFL_TYPE_GRABBER))) {
		 printk(KERN_ERR "dvb: can't register videodevice\n");
		 return -1;
   }

	return 0;
}

void __exit dummy_fini(void)
{
    printk("dummy_fini \n");
   video_unregister_device(&dvb_template);
}

module_init(dummy_init);
module_exit(dummy_fini);
MODULE_DESCRIPTION("dummy module");
MODULE_AUTHOR("Jan Rathert");

